//To do:
//
//Add a save boot state dialog, which would have a "reset everything to
//  factory defaults" button.
//Add "ATX" control setup & host reset watchdog dialog
//Add custom characters dialog ?
//Make window positions and state persistent ? (disagrees with 533I2C_WinTest
//  "no install" convention where only the exe exists. Hmmmm, maybe write
//  back into the exe. That should make the virus scanners happy. :)
//
//============================================================================
// 533I2C_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
//Version 1.9: It is not as ugly as before. But it is still pretty ugly.
//============================================================================
// 533I2C_WinTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "533I2C_WinTest.h"
#include "Live_Display.h"
#include "I2C.h"
#include "GPIO.h"
#include "KeyPads.h"
#include "TempsDlg.h"
#include "Packet_Debug.h"
#include "533I2C_WinTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//==============================================================================
void CMy533I2C_WinTestDlg::Find_Aardvarks(void)
  {
  u16
    aardvark_ports[127];
  u32
    unique_ids[127];
  int
    nelem = 127;
  int
    i;

  //First element is disconnected.
  ports[0].port=-1;
  ports[0].id=0;
  strcpy(ports[0].name,"Not Connected");
  number_of_ports=1;

  // Find all the attached devices
  int
    count;
  count = aa_find_devices_ext(nelem, aardvark_ports, nelem, unique_ids);
  //If there were more than 127 ports returned, only
  //show the first 127.
  if(count > nelem)
    count = nelem;

  //Load the information from the aardvark library into our structure.
  for(i = 0; i < count; ++i)
    {
    ports[number_of_ports].port=aardvark_ports[i];
    ports[number_of_ports].id=unique_ids[i];


    // Determine if the device is in-use
    const char
      *status = "(avail) ";
    if(aardvark_ports[i] & AA_PORT_NOT_FREE)
      {
      aardvark_ports[i] &= ~AA_PORT_NOT_FREE;
      status = "(in-use)";
      }

    sprintf(ports[number_of_ports].name,
            "Total Phase Aardvark: port=%-3d %s (%04d:%06d)",
            aardvark_ports[i],
            status,
            unique_ids[i] / 1000000,
            unique_ids[i] % 1000000);
    number_of_ports++;
    } 
  

  //Load up the pull-down from our structure
  m_port.ResetContent();
  for(i = 0; i < number_of_ports; ++i)
    m_port.AddString(ports[i].name);
  }
//==============================================================================
void CMy533I2C_WinTestDlg::Set_Aardvark_Port(void)
  {
  int
    pull_down;
  char
    status_string[120];

  pull_down=m_port.GetCurSel();
  //If they selected one that is "in use", bail.
  if(strstr(ports[pull_down].name,"(in-use)"))
    m_comm_status.SetWindowText("Port in use. No change made.");
  else
    {
  	//If the pull-down is 0, this is disconnected.
		if(pull_down)
			{
			aardvark_handle = aa_open(ports[pull_down].port);

			//did we fail?
			if(aardvark_handle<0)
				{
				m_comm_status.SetWindowText("Can't open Aardvark.");
				//Set to "disconnected" by default.
				if(0<aardvark_handle)
					{
          Uninit_I2C();
					aa_close(aardvark_handle);
					aardvark_handle=-1;
					}
				selected_port=0;
				}
			else
				{
        //remember what is open successfully
        selected_port=pull_down;
				sprintf(status_string,"Opened Aardvark, handle = %d",aardvark_handle);
				m_comm_status.SetWindowText(status_string);

        I2C_Init();
				}
			}
    else
			{
      Uninit_I2C();
			aa_close(aardvark_handle);
			aardvark_handle=-1;
  		m_comm_status.SetWindowText("Disconnected.");
  		selected_port=0;
  		}
    }

  // Re-populate the list of aardvarks to show it "in-use" or "avail"
  Find_Aardvarks();
	//Update the display to the one that is open.
	m_port.SetCurSel(selected_port);
  }
//------------------------------------------------------------------------------
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
  CAboutDlg();

// Dialog Data
  //{{AFX_DATA(CAboutDlg)
  enum { IDD = IDD_ABOUTBOX };
  //}}AFX_DATA

  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CAboutDlg)
  protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  //}}AFX_VIRTUAL

// Implementation
protected:
  //{{AFX_MSG(CAboutDlg)
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
  //{{AFX_DATA_INIT(CAboutDlg)
  //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(CAboutDlg)
  //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
  //{{AFX_MSG_MAP(CAboutDlg)
    // No message handlers
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy533I2C_WinTestDlg dialog

CMy533I2C_WinTestDlg::CMy533I2C_WinTestDlg(CWnd* pParent /*=NULL*/)
  : CDialog(CMy533I2C_WinTestDlg::IDD, pParent)
  {
  //{{AFX_DATA_INIT(CMy533I2C_WinTestDlg)
  //}}AFX_DATA_INIT
  // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
  m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  //Remember that the packet debugger does not exist yet.
  m_pPacket_Debug = NULL;
  m_pLive_Display = NULL;
  m_pGPIO = NULL;
  m_pKeyPads = NULL;
  m_pTempsDlg = NULL;
  }

void CMy533I2C_WinTestDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(CMy533I2C_WinTestDlg)
	DDX_Control(pDX, IDC_I2C_ADDRESS_CURRENT, m_I2C_Address_Curren);
	DDX_Control(pDX, IDC_I2C_ADDRESS, m_i2c_address);
  DDX_Control(pDX, IDC_PORT_COMBO, m_port);
  DDX_Control(pDX, IDC_COMM_STATUS, m_comm_status);
  DDX_Control(pDX, IDC_ENABLE_LOG, m_enable_log);
  DDX_Control(pDX, IDC_BACKLGHT_SLIDER, m_backlight);
  DDX_Control(pDX, IDC_CONTRAST_SLIDER, m_contrast);
  DDX_Control(pDX, IDC_CONTRAST_PERCENT, m_contrast_percent);
  DDX_Control(pDX, IDC_BACKLIGHT_PERCENT, m_backlight_percent);
  DDX_Control(pDX, IDC_LCD_LINE_2, m_LCD_Line_2);
  DDX_Control(pDX, IDC_LCD_LINE_1, m_LCD_Line_1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy533I2C_WinTestDlg, CDialog)
  //{{AFX_MSG_MAP(CMy533I2C_WinTestDlg)
  ON_WM_QUERYDRAGICON()
  ON_CBN_CLOSEUP(IDC_PORT_COMBO, OnCloseupPortCombo)
  ON_CBN_DROPDOWN(IDC_PORT_COMBO, OnDropdownPortCombo)
  ON_BN_CLICKED(IDC_ENABLE_LOG, OnEnableLog)
  ON_BN_CLICKED(IDC_GPIO, OnGPIO)
  ON_WM_HSCROLL()
  ON_BN_CLICKED(IDC_KEYPADS, OnKeyPads)
  ON_BN_CLICKED(IDC_LIVE_DISPLAY, OnLiveDisplay)
  ON_BN_CLICKED(ID_PACKET_DEBUGGER, OnPacketDebugger)
  ON_WM_PAINT()
  ON_BN_CLICKED(IDC_SEND_LCD_LINE_1, OnSendLcdLine1)
  ON_BN_CLICKED(IDC_SEND_LCD_LINE_2, OnSendLcdLine2)
  ON_WM_SYSCOMMAND()
  ON_BN_CLICKED(IDC_TEMPERATURES, OnTemperatures)
  ON_BN_CLICKED(ID_DONE, OnExit)
	ON_BN_CLICKED(IDC_SEARCH_I2C_ADDRESS, OnSearchI2cAddress)
  ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SET_I2C_ADDRESS, OnSetI2CAddress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
//was 25

#define POLL_INTERVAL 10  //nominally 1/100 sec
#define ID_TIMER1     1
/////////////////////////////////////////////////////////////////////////////
typedef struct
  {
  int
    temps_have_data[32];
  double
    temps[32];
  } LOG_LINE_STRUCT;

LOG_LINE_STRUCT
  log_line;

FILE
  *log_file;

int
  log_count;
/////////////////////////////////////////////////////////////////////////////
#define DEFAULT_CONTRAST 0
/////////////////////////////////////////////////////////////////////////////
// CMy533I2C_WinTestDlg message handlers

BOOL CMy533I2C_WinTestDlg::OnInitDialog()
  {
  CDialog::OnInitDialog();

  // Add "About..." menu item to system menu.

  // IDM_ABOUTBOX must be in the system command range.
  ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
  ASSERT(IDM_ABOUTBOX < 0xF000);

  CMenu* pSysMenu = GetSystemMenu(FALSE);
  if (pSysMenu != NULL)
    {
    CString strAboutMenu;
    strAboutMenu.LoadString(IDS_ABOUTBOX);
    if (!strAboutMenu.IsEmpty())
      {
      pSysMenu->AppendMenu(MF_SEPARATOR);
      pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
      }
    }

  // Set the icon for this dialog.  The framework does this automatically
  //  when the application's main window is not a dialog
  SetIcon(m_hIcon, TRUE);     // Set big icon
  //SetIcon(m_hIcon, FALSE);    // Set small icon
  
  // TODO: Add extra initialization here
  int
    i;
  log_file=NULL;

  for(i=0;i<=31;i++)
    log_line.temps_have_data[i]=0;
  
  //Set the font of the LCD lines to fixed-pitch
  HFONT m_hFont;
  CFont *m_pFont;
  m_hFont = (HFONT)GetStockObject(ANSI_FIXED_FONT);
  m_pFont = CFont::FromHandle (m_hFont);
  m_LCD_Line_1.SetFont (m_pFont);
  m_LCD_Line_2.SetFont (m_pFont);

                            //0123456789012345
  m_LCD_Line_1.SetWindowText("Crystalfontz 533");
  m_LCD_Line_2.SetWindowText("533 I2C  WinTest");

  //Create the (hidden) Packet_Debug dialog. This needs to happen early,
  //since other Create() calls will send packets.
  m_pPacket_Debug = new Packet_Debug(this);
  ASSERT(m_pPacket_Debug != NULL);
  m_pPacket_Debug->Create();

  //Create the (hidden) temps dialog 
  m_pTempsDlg = new TempsDlg(this);
  ASSERT(m_pTempsDlg != NULL);
  m_pTempsDlg->Create();

  //Create the (hidden) KeyPads dialog 
  m_pKeyPads = new KeyPads(this);
  ASSERT(m_pKeyPads != NULL);
  m_pKeyPads->Create();

  //Create the (hidden) Live_Display dialog 
  m_pLive_Display = new Live_Display(this);
  ASSERT(m_pLive_Display != NULL);
  m_pLive_Display->Create();

  //Create the (hidden) GPIO dialog 
  m_pGPIO = new GPIO(this);
  ASSERT(m_pGPIO != NULL);
  m_pGPIO->Create();

  char
    string[10];

  m_contrast.SetRange(-100,+100);
  m_contrast.SetPos(last_contrast=DEFAULT_CONTRAST);
  sprintf(string,"%d",last_contrast);
  m_contrast_percent.SetWindowText(string);

  m_backlight.SetRange(0, 100);
  m_backlight.SetPos(last_backlight=100);
  sprintf(string,"%d%%",last_backlight);
  m_backlight_percent.SetWindowText(string);

  //Initialize the live array
  int
    slot;
  for(slot=0;slot<=7;slot++)
    {
    live[slot].type=0;   //off
    live[slot].index=0;
    live[slot].digits=5; //valid for temp
    live[slot].column=0;
    live[slot].row=0;
    live[slot].units=1;  // 1 PPR or deg F
    }

  Set_I2C_Parent(this);

  //Default address
  I2C_Address=42;
  //Update the fields
  sprintf(string,"%d",I2C_Address);
  m_i2c_address.SetWindowText(string);
  m_I2C_Address_Curren.SetWindowText(string);

  //Default the handle to disconnected.
  aardvark_handle=-1;
	selected_port=0;
  // Populate the list of aardvarks
  Find_Aardvarks();
  //Set to "disconnected" by default.
  m_port.SetCurSel(0);

  //Select the first one that is available
  for(i = 1; i < number_of_ports; ++i)
    if(strstr(ports[i].name,"(avail)"))
      {
      m_port.SetCurSel(i);
      break;
      }

  //Go ahead and open whatever looked good
  Set_Aardvark_Port();

  StartTimer(POLL_INTERVAL);

  //Update things
  update_state=UPDATE_STATE_VERSION;

  return TRUE;  // return TRUE  unless you set the focus to a control
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnExit() 
  {
  StopTimer();
  Uninit_I2C();
  if(log_file)
    fclose(log_file);
  CDialog::OnOK();  
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
  if ((nID & 0xFFF0) == IDM_ABOUTBOX)
  {
    CAboutDlg dlgAbout;
    dlgAbout.DoModal();
  }
  else
  {
    CDialog::OnSysCommand(nID, lParam);
  }
}
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnPaint() 
{
  if (IsIconic())
  {
    CPaintDC dc(this); // device context for painting

    SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

    // Center icon in client rectangle
    int cxIcon = GetSystemMetrics(SM_CXICON);
    int cyIcon = GetSystemMetrics(SM_CYICON);
    CRect rect;
    GetClientRect(&rect);
    int x = (rect.Width() - cxIcon + 1) / 2;
    int y = (rect.Height() - cyIcon + 1) / 2;

    // Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
  {
    CDialog::OnPaint();
  }
}
/////////////////////////////////////////////////////////////////////////////
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMy533I2C_WinTestDlg::OnQueryDragIcon()
  {
  return (HCURSOR) m_hIcon;
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnPacketDebugger(void) 
  {
  //The window is created but invisible. Make it visible
  m_pPacket_Debug->ShowWindow(TRUE);
  m_pPacket_Debug->SetActiveWindow();
   //Disable the button
  GetDlgItem(ID_PACKET_DEBUGGER)->EnableWindow(FALSE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnLiveDisplay(void) 
  {
  //The window is created but invisible. Make it visible
  m_pLive_Display->ShowWindow(TRUE);
  m_pLive_Display->SetActiveWindow();
   //Disable the button
  GetDlgItem(IDC_LIVE_DISPLAY)->EnableWindow(FALSE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnGPIO(void) 
  {
  //The window is created but invisible. Make it visible
  m_pGPIO->ShowWindow(TRUE);
  m_pGPIO->SetActiveWindow();
   //Disable the button
  GetDlgItem(IDC_GPIO)->EnableWindow(FALSE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnKeyPads(void) 
  {
  //The window is created but invisible. Make it visible
  m_pKeyPads->ShowWindow(TRUE);
  m_pKeyPads->SetActiveWindow();
   //Disable the button
  GetDlgItem(IDC_KEYPADS)->EnableWindow(FALSE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnTemperatures(void) 
  {
  //The window is created but invisible. Make it visible
  m_pTempsDlg->ShowWindow(TRUE);
  m_pTempsDlg->SetActiveWindow();
   //Disable the button
  GetDlgItem(IDC_TEMPERATURES)->EnableWindow(FALSE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::Packet_Debugger_Done(void)
  {
  //The window is created and visible. Make it invisible
  m_pPacket_Debug->ShowWindow(FALSE);
  //Re-enable our button
  GetDlgItem(ID_PACKET_DEBUGGER)->EnableWindow(TRUE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::Live_Display_Done(void)
  {
  //The window is created and visible. Make it invisible
  m_pLive_Display->ShowWindow(FALSE);
  //Re-enable our button
  GetDlgItem(IDC_LIVE_DISPLAY)->EnableWindow(TRUE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::GPIO_Done(void)
  {
  //The window is created and visible. Make it invisible
  m_pGPIO->ShowWindow(FALSE);
  //Re-enable our button
  GetDlgItem(IDC_GPIO)->EnableWindow(TRUE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::KeyPads_Done(void)
  {
  //The window is created and visible. Make it invisible
  m_pKeyPads->ShowWindow(FALSE);
  //Re-enable our button
  GetDlgItem(IDC_KEYPADS)->EnableWindow(TRUE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::TempsDlg_Done(void)
  {
  //The window is created and visible. Make it invisible
  m_pTempsDlg->ShowWindow(FALSE);
  //Re-enable our button
  GetDlgItem(IDC_TEMPERATURES)->EnableWindow(TRUE);
  }
/////////////////////////////////////////////////////////////////////////////
//This routine takes a string from the LCD module and replaces "binary"
//characters with the "\xxx" decimal escape sequence. Could make this
//look at hex/dec and ascii checks from the debugger, but it is on the
//main screen which is intended to be less "techie".
void  CMy533I2C_WinTestDlg::Copy_And_Encode_String(char *out,const unsigned char *in,int length)
  {
  out[0]=0;
  int
    i;
  for(i=0;i<length;i++)
    {
    int
      current_length=strlen(out);
    if(isprint(in[i]))
      sprintf(&out[current_length],"%c",in[i]);
    else
      sprintf(&out[current_length],"\\%03d",in[i]);
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::flush_log_line()
  {
   int
    i;
  char
    date_buffer[19];
  char
    time_buffer[19];
  if(log_file)
    {
    _strdate(date_buffer);
    _strtime(time_buffer);
    fprintf(log_file,"%s,%s,",date_buffer,time_buffer);
    }

   //Dump out the temperatures.
  for(i=0;i<=31;i++)
    {
    if(log_file)
      {
      if(log_line.temps_have_data[i]==1)
        fprintf(log_file,"%9.4f%s",log_line.temps[i],i==31?"\n":",");
      else
        if(log_line.temps_have_data[i]==2)
          fprintf(log_file,"\"CRC!\"%s",i==31?"\n":",");
        else
          fprintf(log_file,"%s",i==31?"\n":",");
      }
    log_line.temps_have_data[i]=0;
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::log_temp(int index,double temp,int data_good)
  {
  //first, see if it can fit in the first slot.
  if(!log_line.temps_have_data[index])
    {
    if(data_good)
      log_line.temps_have_data[index]=1;
    else
      log_line.temps_have_data[index]=2;
    log_line.temps[index]=temp;
    }
  else
    {
    //time to flush the line
    flush_log_line();
    //Now put it in the first slot
    if(data_good)
      log_line.temps_have_data[index]=1;
    else
      log_line.temps_have_data[index]=2;
    log_line.temps[index]=temp;
    }
  }
/////////////////////////////////////////////////////////////////////////////
//This function may have been better placed in Packet_Debug.cpp
void CMy533I2C_WinTestDlg::OnTimer(UINT nIDEvent) 
  {
  if (nIDEvent == ID_TIMER1)
    {
    //See if any new packets have come in from the LCD module.
    if(check_for_packet())
      {
      m_pPacket_Debug->Record_Received_Packet(&incoming_response);

      unsigned char
        spinner_has_been_updated;
      spinner_has_been_updated=0;

      //Update the fields on the main window.
      switch(incoming_response.command)
        {
        case 0x80:  //Key
          m_pPacket_Debug->RollKeySpinner();
          spinner_has_been_updated=1;
          //Send the packet up to the KeyPad window
          m_pKeyPads->OnReceivedKeyReport(&incoming_response);
          break;
        case 0x40|15: //Read Temperature
        case 0x82:    //Temp reporting
          m_pPacket_Debug->RollTemperatureSpinner();
          spinner_has_been_updated=1;
          //Send the packet up to the Temperatures window
          m_pTempsDlg->OnReceivedTempReport(&incoming_response);
          break;
        case (0x40|18):  //Return packet from Read DOW Device information
          //Send the packet up to the Temperatures window
          m_pTempsDlg->OnReceivedSensorID(&incoming_response);
          break;

        case (0x40|0):  //Return packet from PING
          if(I2C_Address_Search_State==I2C_ADDRESS_SEARCH_STATE_WAITING)
            {
            //Print out the successful address
						char
              string[50];
            sprintf(string,"Found at I2C address %d",incoming_response.data[0]);
            m_comm_status.SetWindowText(string);

            //Stop looking
            I2C_Address_Search_State=I2C_ADDRESS_SEARCH_STATE_IDLE;

            //Update things
            update_state=UPDATE_STATE_VERSION;
            }
          break;

        case (0x40|1):  //Return packet from get ROM version
          if(update_state==UPDATE_STATE_VERSION_REPLY)
            {
            //Remove the "No module found." message and display the module type
            incoming_response.data[incoming_response.data_length]=0;
            char
              string[50];
            sprintf(string,"Found: %s",(char *)incoming_response.data);
            m_comm_status.SetWindowText(string);
            update_state=UPDATE_STATE_MODULE_FOUND;
            }
          break;
        case (0x40|24):  //Return packet from Read Keypad, Polled Mode
          //Send the packet up to the KeyPad window if it exists.
          if(m_pKeyPads)
            m_pKeyPads->OnReceivedKeyPoll(&incoming_response);
          break;
        case (0x40|30):  //Return packet from Read Reporting Status
          //Send the packet up to the Temperature window
          m_pTempsDlg->OnReceivedReportingStatus(&incoming_response);

          //Send the packet up to the KeyPad window
          m_pKeyPads->OnReceivedReportingStatus(&incoming_response);

          char
            string[10];

          //The contrast
          last_contrast=incoming_response.data[9]-100;
          m_contrast.SetPos(last_contrast);
          sprintf(string,"%d",last_contrast);
          m_contrast_percent.SetWindowText(string);
          //The backlight
          m_backlight.SetPos(last_backlight=incoming_response.data[14]);
          sprintf(string,"%d%%",last_backlight);
          m_backlight_percent.SetWindowText(string);
          break;
        case (0x40|35):  //Return packet from Read GPIO pin levels and configuration state
          //Send the packet up to the GPIO window
          m_pGPIO->OnReceivedState(&incoming_response);
          break;
        case (0x40|10):  //Return packet from Read 8 bytes of LCD memory
          static char
            LCD_Image[2][20*4+1]; //worst case for "/xxx" in all positions
          switch(incoming_response.data[0])
            {
            case 128:    //top line, left
              Copy_And_Encode_String(&LCD_Image[0][0],
                                     &incoming_response.data[1],
                                     8);
              update_state=UPDATE_STATE_LCD_1;
              break;
            case 128+8:  //top line, right
              Copy_And_Encode_String(&LCD_Image[0][strlen(&LCD_Image[0][0])],
                                     &incoming_response.data[1],
                                     8);
              update_state=UPDATE_STATE_LCD_2;
              //Update the edit fields with the module's LCD's contents
              m_LCD_Line_1.SetWindowText(LCD_Image[0]);
              break;
            case 192:    //bottom line, left
              Copy_And_Encode_String(&LCD_Image[1][0],
                                     &incoming_response.data[1],
                                     8);
              update_state=UPDATE_STATE_LCD_3;
              break;
            case 192+8:  //bottom line, right
              Copy_And_Encode_String(&LCD_Image[1][strlen(&LCD_Image[1][0])],
                                     &incoming_response.data[1],
                                     8);
              //Update the edit fields with the module's LCD's contents
              m_LCD_Line_2.SetWindowText(LCD_Image[1]);
              break;
            }
          break;
        }

      if(!spinner_has_been_updated)
        m_pPacket_Debug->RollAcknowledgeSpinner();
      }

    COMMAND_PACKET
      command_to_LCD;
    switch(update_state)
      {
      case UPDATE_STATE_VERSION:
        m_comm_status.SetWindowText("Looking for module . . .");
        //Send a firmware version request.
        command_to_LCD.command=1;
        command_to_LCD.data_length=0;
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
        update_state=UPDATE_STATE_VERSION_REPLY;
        update_state_timer=30; //300mS
        break;
      case UPDATE_STATE_VERSION_REPLY:
        update_state_timer--;
        if(!update_state_timer)
          {
          update_state=UPDATE_STATE_IDLE;
          char
            string[150];
         	sprintf(string,"No module at I2C address %d",I2C_Address);
          m_comm_status.SetWindowText(string);
          }
        break;
      case UPDATE_STATE_MODULE_FOUND:
        //Send a Read 8 bytes of LCD memory request.
        command_to_LCD.command=10;
        command_to_LCD.data_length=1;
        command_to_LCD.data[0]=128; //top line, left
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Send a Read 8 bytes of LCD memory request.
        command_to_LCD.command=10;
        command_to_LCD.data_length=1;
        command_to_LCD.data[0]=128+8; //top line, right
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Send a Read 8 bytes of LCD memory request.
        command_to_LCD.command=10;
        command_to_LCD.data_length=1;
        command_to_LCD.data[0]=192; //bottom line, left
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Send a Read 8 bytes of LCD memory request.
        command_to_LCD.command=10;
        command_to_LCD.data_length=1;
        command_to_LCD.data[0]=192+8; //bottom line, right
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Send a Read Reporting Status request.
        command_to_LCD.command=30;
        command_to_LCD.data_length=0;
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Let the temperature dialog get in on the fun
        m_pTempsDlg->LCDModuleBootComplete();
        //and the GPIO dialog
        m_pGPIO->LCDModuleBootComplete();

        //The initialization is complete.
        update_state=UPDATE_STATE_IDLE;
        break;
      }

    switch(I2C_Address_Search_State)
      {
      case I2C_ADDRESS_SEARCH_STATE_SEND:
        char
          status_string[200];
        sprintf(status_string,"Trying I2C address %3i",I2C_Address);
        m_comm_status.SetWindowText(status_string);

        //Send a ping request.
        command_to_LCD.command=0;
        command_to_LCD.data_length=1;
        command_to_LCD.data[0]=I2C_Address;
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
        I2C_Address_Search_State=I2C_ADDRESS_SEARCH_STATE_WAITING;
        I2C_Address_Search_Timer=10;
        break;
      case I2C_ADDRESS_SEARCH_STATE_WAITING:
        I2C_Address_Search_Timer--;
        if(!I2C_Address_Search_Timer)
          {
          //Give up on this address
          I2C_Address++;
          if(127<I2C_Address)
            {
            //Report no modules found
            m_comm_status.SetWindowText("No module at addresses 0 to 127");
            //Can't find a module
            I2C_Address_Search_State=I2C_ADDRESS_SEARCH_STATE_IDLE;

						//Default address
						I2C_Address=42;
            }
          else
            I2C_Address_Search_State=I2C_ADDRESS_SEARCH_STATE_SEND;

					//Update the field
					char
						string[10];
					sprintf(string,"%d",I2C_Address);
					m_I2C_Address_Curren.SetWindowText(string);
          }
        break;
      }

    //Expire any any packets that may have been waiting too long
    //for their acknowedges.
    m_pPacket_Debug->Timeout_No_Repsonse_Packets();
    }
  // default processing
  CDialog::OnTimer(nIDEvent);
  }
/////////////////////////////////////////////////////////////////////////////
//  Parameters: int iTimeInterval - timer resolution in miliseconds.
//  max resolution is 55 ms.
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::StartTimer (int iTimeInterval)
  {
  // here we go...
  SetTimer (ID_TIMER1, iTimeInterval, NULL);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::StopTimer (void)
  {
  // kill the timer
  KillTimer (ID_TIMER1);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
  {
  int
    new_contrast;
  char
    string[10];
  COMMAND_PACKET
    command_to_LCD;
  new_contrast=m_contrast.GetPos();
  if(last_contrast!=new_contrast)
    {
    command_to_LCD.command=13;
    command_to_LCD.data_length=2;
    command_to_LCD.data[0]=0;
    command_to_LCD.data[1]=new_contrast+100;

    //this does the CRC and sends it.
    m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

    sprintf(string,"%d",new_contrast);
    m_contrast_percent.SetWindowText(string);
    last_contrast=new_contrast;
    }

  int
    new_backlight;
  new_backlight=m_backlight.GetPos();
  if(last_backlight!=new_backlight)
    {
    command_to_LCD.command=14;
    command_to_LCD.data[0]=new_backlight;
    command_to_LCD.data_length=1;

    //this does the CRC and sends it.
    m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

    sprintf(string,"%d%%",new_backlight);
    m_backlight_percent.SetWindowText(string);

    last_backlight=new_backlight;
    }
  CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnSendLcdLine1() 
  {
  char
    string[160];
  COMMAND_PACKET
    command_to_LCD;
  //Get the string
  m_LCD_Line_1.GetWindowText(string,160);

  command_to_LCD.command=31;
  command_to_LCD.data[0]=0; //col  = x = 0
  command_to_LCD.data[1]=0; //row  = y = 0
  //Convert escape sequences & copy into &data[2]
  command_to_LCD.data_length=
    m_pPacket_Debug->Convert_Input_String_To_Array(
      string,
      &command_to_LCD.data[2]);
  //Pad it out with spaces
  if(16<command_to_LCD.data_length)
    command_to_LCD.data_length=16;
  else
    while(command_to_LCD.data_length<16)
      command_to_LCD.data[2+command_to_LCD.data_length++]=' ';
  //Account for col & row
  command_to_LCD.data_length+=2;

  //Send it to the 533I2C.
  //this does the CRC and sends it.
  m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnSendLcdLine2() 
  {
  char
    string[160];
  //Get the string
  m_LCD_Line_2.GetWindowText(string,160);

  COMMAND_PACKET
    command_to_LCD;

  command_to_LCD.command=31;
  command_to_LCD.data[0]=0; //col  = x = 0
  command_to_LCD.data[1]=1; //row  = y = 1
  //Convert escape sequences & copy into &data[2]
  command_to_LCD.data_length=
    m_pPacket_Debug->Convert_Input_String_To_Array(
      string,
      &command_to_LCD.data[2]);
  //Pad it out with spaces
  if(16<command_to_LCD.data_length)
    command_to_LCD.data_length=16;
  else
    while(command_to_LCD.data_length<16)
      command_to_LCD.data[2+command_to_LCD.data_length++]=' ';
  //Account for col & row
  command_to_LCD.data_length+=2;

  //Send it to the 533I2C.
  //this does the CRC and sends it.
  m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
  }
/////////////////////////////////////////////////////////////////////////////
//Called by daughter windows to communicate with the LCD module. Basically
//a non protected call to the protected Queue_Outgoing_Packet so
//m_pPacket_Debug does not have to be public.
void CMy533I2C_WinTestDlg::QueuePacket(COMMAND_PACKET *packet)
  {
  //this does the CRC and sends it.
  m_pPacket_Debug->Queue_Outgoing_Packet(packet);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnEnableLog() 
  {
  if(m_enable_log.GetCheck())
    {
    //just got checked, start logging.
    log_count=0;
    if(log_file)
      fclose(log_file);
    log_file=fopen("533_log.csv","at");
    if(log_file)
      {
      //Get the string
      CString
        input_string;
      char
        string[160];
      m_LCD_Line_1.GetWindowText(input_string);
      strcpy(string,(LPSTR)(const char *)input_string);
      fprintf(log_file,"//Logging started. L1=\"%s\" ",string);
      m_LCD_Line_2.GetWindowText(input_string);
      strcpy(string,(LPSTR)(const char *)input_string);
      fprintf(log_file,"L2=\"%s\"\n",string);
      fprintf(log_file,"\"Date\",\"Time\",");

      int
        i;
      for(i=1;i<=32;i++)
        fprintf(log_file,"\"Temp %2d\"%s",i,i==32?"\n":",");
      for(i=0;i<=31;i++)
        log_line.temps_have_data[i]=0;
      }
    else
      m_enable_log.SetCheck(0);
    }
   else
    {
    //just got un-checked, stop logging.
    if(log_file)
      {
      fclose(log_file);
      log_file=NULL;
      }
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnCloseupPortCombo() 
  {
  Set_Aardvark_Port();
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnDropdownPortCombo() 
  {
  //Close the port
  Uninit_I2C();
  //Remember what is open
  int
    port;
  port=m_port.GetCurSel();
  //Re-enumerate
  Find_Aardvarks();
  //Pre-select what was open
  m_port.SetCurSel(port);
  }
/////////////////////////////////////////////////////////////////////////////
//should move to live_display.cpp
void CMy533I2C_WinTestDlg::Send_Live_Data_To_Display(void)
  {
  COMMAND_PACKET
    command_to_LCD;
  int
    slot;
  for(slot=0;slot<=3;slot++)
    {
    //Build up the packet
    command_to_LCD.command=21;
    command_to_LCD.data[0]=slot;
    command_to_LCD.data[1]=live[slot].type;
    if(live[slot].type)
      {
      command_to_LCD.data_length=7;
      command_to_LCD.data[2]=live[slot].index;
      command_to_LCD.data[3]=live[slot].digits;
      command_to_LCD.data[4]=live[slot].column;
      command_to_LCD.data[5]=live[slot].row;
      command_to_LCD.data[6]=live[slot].units;
      }
    else
      command_to_LCD.data_length=2;
    //Send it to the Display.
    //this does the CRC and sends it.
    m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
    Sleep(5);
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnSearchI2cAddress() 
  {
  I2C_Address=0;
  I2C_Address_Search_State=I2C_ADDRESS_SEARCH_STATE_SEND;
	//Update the field
	char
		string[10];
	sprintf(string,"%d",I2C_Address);
	m_I2C_Address_Curren.SetWindowText(string);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy533I2C_WinTestDlg::OnSetI2CAddress() 
  {
  COMMAND_PACKET
    command_to_LCD;

  char
    string[160];

  m_i2c_address.GetWindowText(string,160);

  int
    address=0;
  address=atoi(string);
  if(address<0)
    address=0;
  if(127<address)
    address=127;
  sprintf(string,"%d",address);
  m_i2c_address.SetWindowText(string);

  //Build up the packet. Send out under the old address.
  command_to_LCD.command=33;
  command_to_LCD.data_length=1;
  command_to_LCD.data[0]=address;
  m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
  Sleep(100);

  //Update the I2C system to use the new address.
  I2C_Address=address;

  //Post it under the current address field.
  m_I2C_Address_Curren.SetWindowText(string);

  //Update things
  update_state=UPDATE_STATE_VERSION;
  }
/////////////////////////////////////////////////////////////////////////////
