//============================================================================
// 533I2C_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
// 533I2C_WinTestDlg.h : header file
//

#if !defined(AFX_533I2C_WINTESTDLG_H__E0E13B84_E9DC_4F3C_84AC_EEF4AA15262D__INCLUDED_)
#define AFX_533I2C_WINTESTDLG_H__E0E13B84_E9DC_4F3C_84AC_EEF4AA15262D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMy533I2C_WinTestDlg dialog

//keeps track of the boot/update process
#define UPDATE_STATE_IDLE                    0
#define UPDATE_STATE_VERSION                 1
#define UPDATE_STATE_VERSION_REPLY           2
#define UPDATE_STATE_LCD_0                   3
#define UPDATE_STATE_LCD_0_REPLY             4
#define UPDATE_STATE_LCD_1                   5
#define UPDATE_STATE_LCD_1_REPLY             6
#define UPDATE_STATE_LCD_2                   7
#define UPDATE_STATE_LCD_2_REPLY             8
#define UPDATE_STATE_LCD_3                   9
#define UPDATE_STATE_LCD_3_REPLY             10
#define UPDATE_STATE_MODULE_FOUND            11


#define I2C_ADDRESS_SEARCH_STATE_IDLE        0
#define I2C_ADDRESS_SEARCH_STATE_SEND        1
#define I2C_ADDRESS_SEARCH_STATE_CHECK       2
#define I2C_ADDRESS_SEARCH_STATE_WAITING     3

typedef struct
  {
  unsigned char type;
  unsigned char index;
  unsigned char digits;
  unsigned char column;
  unsigned char row;
  unsigned char units;
  } LIVE_DISPLAY_STRUCT;

typedef struct
  {
  unsigned char index;
  unsigned char output;
  unsigned char function;
  } GPIO_STRUCT;

//------------------------------------------------------------------------------

class CMy533I2C_WinTestDlg : public CDialog
{
// Construction
public:
  CMy533I2C_WinTestDlg(CWnd* pParent = NULL);  // standard constructor

  //These functions allow us to re-enable our buttons.
  void CMy533I2C_WinTestDlg::Packet_Debugger_Done(void);
  void CMy533I2C_WinTestDlg::Live_Display_Done(void);
  void CMy533I2C_WinTestDlg::GPIO_Done(void);
  void CMy533I2C_WinTestDlg::KeyPads_Done(void);
  void CMy533I2C_WinTestDlg::TempsDlg_Done(void);

  //This function allows the dialogs to sent packets
  void CMy533I2C_WinTestDlg::QueuePacket(COMMAND_PACKET *packet);

  //these should move to Live_Display
  void CMy533I2C_WinTestDlg::Send_Live_Data_To_Display(void);
  LIVE_DISPLAY_STRUCT CMy533I2C_WinTestDlg::live[8];

  //these should move to GPIO
  GPIO_STRUCT CMy533I2C_WinTestDlg::gpio[5];

  //public for TempsDlg::OnRebootToRedetect()
  int update_state;
  //public for TempsDlg::OnReceivedTempReport()
  void CMy533I2C_WinTestDlg::log_temp(int index,double temp,int data_good);

  //public for TempsDlg::OnReceivedReportingStatus()
  //to access GPIO::TemperatureInitializationComplete()
  GPIO* m_pGPIO;

  //This is is the address that is used to send and receive packets
  int I2C_Address;

  //Set if we are searching through I2C_addresses
  int I2C_Address_Search_State;
  int I2C_Address_Search_Timer;

// Dialog Data
  //{{AFX_DATA(CMy533I2C_WinTestDlg)
	enum { IDD = IDD_MY533I2C_WINTEST_DIALOG };
	CEdit	m_I2C_Address_Curren;
	CEdit	m_i2c_address;
  CComboBox m_port;
  CEdit m_comm_status;
  CButton m_enable_log;
  CSliderCtrl m_backlight;
  CSliderCtrl m_contrast;
  CEdit m_contrast_percent;
  CEdit m_backlight_percent;
  CEdit m_LCD_Line_2;
  CEdit m_LCD_Line_1;
	//}}AFX_DATA

  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CMy533I2C_WinTestDlg)
  protected:
  virtual void DoDataExchange(CDataExchange* pDX);  // DDX/DDV support
  //}}AFX_VIRTUAL

// Implementation
protected:
  HICON m_hIcon;
  KeyPads* m_pKeyPads;
  TempsDlg* m_pTempsDlg;
  Live_Display* m_pLive_Display;
  Packet_Debug* m_pPacket_Debug;
  unsigned char last_glitch_settings[4];
  void CMy533I2C_WinTestDlg::OnSendPacket(void);
  void CMy533I2C_WinTestDlg::Copy_And_Encode_String(char *out,const unsigned char *in,int length);
  void CMy533I2C_WinTestDlg::flush_log_line(void);
  void CMy533I2C_WinTestDlg::OnTimer(UINT nIDEvent);
  void CMy533I2C_WinTestDlg::StartTimer (int iTimeInterval);
  void CMy533I2C_WinTestDlg::StopTimer (void);
  void CMy533I2C_WinTestDlg::Find_Aardvarks(void);
  void CMy533I2C_WinTestDlg::Set_Aardvark_Port(void);
  int last_contrast;
  int last_backlight;
  int update_state_timer;
  // Generated message map functions
  //{{AFX_MSG(CMy533I2C_WinTestDlg)
  virtual BOOL OnInitDialog();
  afx_msg HCURSOR OnQueryDragIcon();
  afx_msg void OnCloseupPortCombo();
  afx_msg void OnDropdownPortCombo();
  afx_msg void OnEnableLog();
  afx_msg void OnGPIO();
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
  afx_msg void OnKeyPads();
  afx_msg void OnLiveDisplay();
  afx_msg void OnPacketDebugger();
  afx_msg void OnPaint();
  afx_msg void OnSendLcdLine1();
  afx_msg void OnSendLcdLine2();
  afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
  afx_msg void OnTemperatures();
  afx_msg void OnExit();
	afx_msg void OnSearchI2cAddress();
	afx_msg void OnSetI2CAddress();
	//}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_533I2C_WINTESTDLG_H__E0E13B84_E9DC_4F3C_84AC_EEF4AA15262D__INCLUDED_)
